﻿using System;

namespace Mono.ILASM
{
	public class FieldInstr : IInstr
	{
		PEAPI.FieldOp op;
		IFieldRef operand;

		public FieldInstr(PEAPI.FieldOp op, IFieldRef operand, Location loc)
			: base(loc)
		{
			this.op = op;
			this.operand = operand;
		}

		public override void Emit(CodeGen code_gen, MethodDef meth, PEAPI.CILInstructions cil)
		{
			operand.Resolve(code_gen);
			cil.FieldInst(op, operand.PeapiField);
		}
	}
}
