﻿using System;

namespace Mono.ILASM
{
	public class FieldRef : IFieldRef
	{
		public FieldRef(TypeRef owner, BaseTypeRef ret_type, string name)
		{
			this.owner = owner;
			this.ret_type = ret_type;
			this.name = name;

			is_resolved = false;
		}

		TypeRef owner;
		BaseTypeRef ret_type;
		string name;

		bool is_resolved;
		PEAPI.Field peapi_field;

		public PEAPI.Field PeapiField => peapi_field;

		public void Resolve(CodeGen code_gen)
		{
			if (is_resolved)
				return;

			TypeDef owner_def = code_gen.TypeManager[owner.FullName];
			peapi_field = owner_def.ResolveField(name, ret_type, code_gen);

			is_resolved = true;
		}
	};
}
