﻿using System;
using System.Collections;

namespace Mono.ILASM
{
	public class GenericMethodSig
	{
		GenericArguments gen_args;
		bool is_resolved;
		PEAPI.GenericMethodSig sig;

		static Hashtable sig_table;

		public GenericMethodSig(GenericArguments gen_args)
		{
			this.gen_args = gen_args;
			is_resolved = false;
		}

		public PEAPI.GenericMethodSig Sig => sig;

		public PEAPI.GenericMethodSig Resolve(CodeGen code_gen)
		{
			if (is_resolved)
				return sig;

			sig = new PEAPI.GenericMethodSig(gen_args.Resolve(code_gen));
			is_resolved = true;

			return sig;
		}

		public static GenericMethodSig GetInstance(GenericArguments gen_args)
		{
			GenericMethodSig sig = null;

			if (sig_table == null)
				sig_table = new Hashtable();
			else
				sig = (GenericMethodSig)sig_table[gen_args.ToString()];

			if (sig == null)
			{
				sig = new GenericMethodSig(gen_args);
				sig_table[gen_args.ToString()] = sig;
			}

			return sig;
		}
	}
}
