﻿using System;

namespace Mono.ILASM
{
	public class GlobalFieldRef : IFieldRef
	{
		public GlobalFieldRef(BaseTypeRef ret_type, string name)
		{
			this.ret_type = ret_type;
			this.name = name;

			is_resolved = false;
		}

		BaseTypeRef ret_type;
		string name;

		PEAPI.Field peapi_field;
		bool is_resolved;

		public PEAPI.Field PeapiField => peapi_field;

		public void Resolve(CodeGen code_gen)
		{
			if (is_resolved)
				return;

			peapi_field = code_gen.ResolveField(name, ret_type.FullName);

			is_resolved = true;
		}
	};
}
