﻿using System;

namespace Mono.ILASM
{
	public class Local
	{
		public Local(int slot, string name, BaseTypeRef type)
		{
			this.slot = slot;
			this.name = name;
			this.type = type;
		}

		public Local(int slot, BaseTypeRef type)
			: this(slot, null, type)
		{
		}

		int slot;
		string name;
		BaseTypeRef type;

		public int Slot
		{
			get => slot;
			set => slot = value;
		}

		public string Name => name;

		public BaseTypeRef Type => type;

		public PEAPI.Local GetPeapiLocal(CodeGen code_gen)
		{
			int ec = Report.ErrorCount;
			BaseGenericTypeRef gtr = type as BaseGenericTypeRef;
			if (gtr == null)
				type.Resolve(code_gen);
			else
				gtr.ResolveNoTypeSpec(code_gen);

			if (Report.ErrorCount > ec)
				return null;

			return new PEAPI.Local(name, type.PeapiType);
		}
	};
}
