﻿using System.Collections;

namespace Mono.ILASM
{
	public class PermissionSet
	{
		PEAPI.SecurityAction sec_action;
		ArrayList permissions;
		PEAPI.PermissionSet ps;

		public PermissionSet(PEAPI.SecurityAction sec_action, ArrayList permissions)
		{
			this.sec_action = sec_action;
			this.permissions = permissions;
		}

		public ArrayList Permissions => permissions;

		public PEAPI.SecurityAction SecurityAction => sec_action;

		public void AddPermission(Permission perm)
		{
			permissions.Add(perm);
		}

		public PEAPI.PermissionSet Resolve(CodeGen code_gen)
		{
			ps = new PEAPI.PermissionSet(sec_action);
			foreach (Permission perm in permissions)
				ps.AddPermission(perm.Resolve(code_gen));

			return ps;
		}
	}
}
