﻿using System;

namespace Mono.ILASM
{
	public class TypeSpecFieldRef : IFieldRef
	{
		BaseTypeRef owner;
		BaseTypeRef type;
		string name;

		PEAPI.FieldRef peapi_field;
		bool is_resolved;

		public TypeSpecFieldRef(BaseTypeRef owner, BaseTypeRef type, string name)
		{
			this.owner = owner;
			this.type = type;
			this.name = name;

			is_resolved = false;
		}

		public PEAPI.Field PeapiField => peapi_field;

		public void Resolve(CodeGen code_gen)
		{
			if (is_resolved)
				return;

			owner.Resolve(code_gen);

			type.Resolve(code_gen);
			peapi_field = code_gen.PEFile.AddFieldToTypeSpec(owner.PeapiType, name, type.PeapiType);

			is_resolved = true;
		}
	}
}
