﻿using System;
using System.Text;

namespace Mono.ILASM
{
	internal abstract class StringHelperBase
	{
		protected ILTokenizer host;
		protected int mode;

		public StringHelperBase(ILTokenizer host)
		{
			this.host = host;
			mode = Token.UNKNOWN;
		}

		public abstract bool Start(char ch);

		public bool Start(int ch)
		{
			return Start((char)ch);
		}

		public bool Start()
		{
			return Start(host.Reader.Peek());
		}

		public abstract string Build();

		public int TokenId => mode;
	}
}
